# -*- coding: cp1252 -*-
''' Ce client introge priodement le serveur (serveur.py) et s'il rpond (actif) met  jour un fichier watchdog
associ (serveurWatchDog.txt). Un processus pre (serveurWatch.py) surveille son fils (serveur.py, le serveur),
si le serveur est plant le watchdog n'est plus mis  jour, si trop ancien le pre tue son fils et le relance
(voir le module watch.py)
La connexion entre client et serveur est faite via un socket IP, ce n'est pas une requte GET impliquant
l'interrogation de l'automate (M3) et une connexion Internet, le dialogue entre client et serveur est 'localhost',
tous 2 tournent sur le mme PC, point d'Internet, la rponse est instantane. 
'''

from    defGen  import  CFG_NAME, SERVEUR, initLog, sleep, module, watchDog, abort, readConfig, runScript, logVers, myselfSansExt, outTime, PERIODE, PORT
import  logging as      log
import  socket

VERSION         = '30/01/18'

def config(fileName=CFG_NAME):
    '''Lit la configuration et la retourne dans un objet
    '''
    class Config(object):
        '''Objet pour contenir les attributs de configuration
        '''
        pass

    cfg = Config()

    # lit le fichier de configuration
    cp = readConfig(fileName, {
        PERIODE:60
        })
        
    section = SERVEUR
    cfg.periode     = cp.getint(section,    PERIODE)
    cfg.port        = cp.getint(section,    PORT)
    
    # s'arrte si la priodicit des requts n'est pas un multiple de 60 (60 sec/min)
    if cfg.periode < 60 or cfg.periode % 60:
        abort('La priodicit de surveillance par le client doit tre un multiple de 60 (secondes)')

    # Rappel configuration
    log.info(u'     priodicit des requtes au serveur (%s) = %s' % (module(SERVEUR).extPy(), outTime(cfg.periode)))
    log.info(u'     port IP = %s' % cfg.port)

    return cfg

def main():

    # configure la journalisation du client, nom de ce fichier sans son extension Python
    initLog(myselfSansExt())

    # dmarrage avec version
    logVers('Client', VERSION)

    # lecture configuration
    cfg = config()
    
    while 1:
        # Endort le processus jusqu' prochaine requte au serveur
        sleep(cfg.periode)

        # Cration du socket
        Socket = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
 
        # connexion  ce socket (serveur)
        try:
            Socket.connect(('localhost', cfg.port))
            Socket.close()
            # met  jour le fichier watchdog surveill par le processus pre du serveur
            watchDog(SERVEUR).update()
        except:
            log.warning(u'Echec lors de la connexion au serveur')
        
####################
# lancement automatique du script
if __name__ == '__main__':
    runScript(main)
